<?php
/*
     TODO: 
       non si capisce quando gimp sta rendendo un errore
       nomi file di appoggio con un qualche id univoco per la race
       FATTO - capire perch sminchia dopo la prima img (i newlay vanno puliti)
       FATTO - rendere opzionale la finger (modificando opportunamente lo script)

       
       FATTO - form inserimento dati
       FATTO - correggere canvas
       FATTO - ritorno al web dell'immagine
       FATTO - pulizia della mem di gimp


*/
define("UPFILE_PATH", "/var/www/gimp_server_files");

// echo "SUB $SUB<br>";

//
//  MAIN
//

function elaborate()
{
  GLOBAL $userfile, $userfile_name, $userfile_size, $userfile_type;
  GLOBAL $nome, $cogn, $via, $citt, $numtes, $email, $finger1, $finger2;

  $ret = 0;
  
  // printf("QUI [%s]<br>\n", $userfile);
  if (is_uploaded_file($userfile)) {
    require_once("lib/gimphp.php");
    
    // printf("QUI2<br>\n");
  
    $fname = UPFILE_PATH."/".basename($userfile_name);
    move_uploaded_file($userfile, $fname);

    // echo "$userfile<br>";
    // echo "$userfile_name<br>";
    // echo "$userfile_size<br>";
    // echo "$userfile_type<br>";

    do {
      if (($gimp = new gimp("/tmp/gimp-socket")) == false) {
	$errs = "Creazione classe gimp fallita";  $err = 1;  break; }

      // apre la socket
      if ($gimp->open_connection() == false) {
	$errs = "Apertura socket fallita";  $err = 1;	break; }

      // carica il file inviato via web
      if (($in_img = $gimp->file_load($fname)) == false) {
	$errs = "Apertura file [".$fname."]";  $err = 2; break; }

      // cancella il file di input dal disco
      unlink($fname);

      // legge le dim dell'immagine in input
      $in_w = $gimp->image_width($in_img);
      $in_h = $gimp->image_height($in_img);
      $in_crop = ($in_w < $in_h ? $in_w : $in_h);

      // la ridimensione in forma quadrangolare e la scala a 500x500
      if ($gimp->image_crop($in_img, $in_crop, $in_crop, 0, 0) == false) {
	$errs = "Crop error\n";  $err = 3;  break; }

      if ($gimp->image_scale($in_img, 500, 500) == false) {
	$errs = "Scale error\n";  $err = 4; break; }
      
      // trova il laher attivo e ne fa una copia
      if (($in_lay = $gimp->image_get_active_layer($in_img)) == false) {
	$errs = "Active layer\n";  $err = 5; break; }

      if (($in_lcopy = $gimp->layer_copy($in_lay, true)) == false) {
	$errs = "Copy layer\n";  $err = 6; break; }

      // aggiunge il layer copia all'immagine e ci fa lavorare sopra il d.o.g. 
      if ($gimp->image_add_layer($in_img, $in_lcopy, -1) == false) {
	$errs = "Add layer\n";  $err = 7; break; }

      if ($gimp->plug_in_dog($in_img, $in_lcopy, 6, 2, true, true) == false) {
	$errs = "Dog plug-in\n";  $err = 8; break; }

      // legge l'id del layer mask server provided
      if (($lmask = $gimp->server_get_mask_lid()) == false) {
	$errs = "Get mask lid\n";  $err = 9; break; }
      
      // crea una mask per il layer copia
      if (($newmask = $gimp->layer_create_mask($in_lcopy, "BLACK")) == false){
	$errs = "Layer create mask\n";  $err = 10; break; }

      if ($gimp->layer_add_mask($in_lcopy,$newmask) == false) {
	$errs = "Add mask\n";  $err = 11; break; }

      // in transazione, copia il layer mask e lo incolla sul nuovo layer
      if ($gimp->server_transact_begin() == false) {
	$errs = "Transact begin\n";  $err = 12; break; }

      if ($gimp->edit_copy($lmask) == false) {
	$errs = "Edit copy\n";  $err = 13; break; }

      if (($floatsel = $gimp->edit_paste($newmask)) == false) {
	$errs = "Edit paste\n";  $err = 14; break; }

      if ($gimp->floating_sel_anchor($floatsel) == false) {
	$errs = "FSel anchor\n";  $err = 15; break; }

      if ($gimp->server_transact_finish() == false) {
	$errs = "Transact finish\n";  $err = 16; break; }
      
      // applica la mask
      if ($gimp->layer_remove_mask($in_lcopy,"APPLY") == false) {
	$errs = "Apply mask\n";  $err = 17; break; }

      // desatura il layer copia fino al grayscale
      if ($gimp->layer_to_gray($in_lcopy) == false) {
	$errs = "Layer to gray\n";  $err = 18; break; }

      // appiattisce l'immagine, la scala a 1000x1000
      if (($flatten = $gimp->image_flatten($in_img)) == false) {
	$errs = "Image flatten\n";  $err = 19; break; }
      
      if ($gimp->image_scale($in_img,1000,1000) == false) {
	$errs = "Image scale\n";  $err = 20; break; }

      // Clonazione del canvas XXXX
      if (($canvas_img = $gimp->server_get_canvas_id()) == false) {
	$errs = "Get canvas id\n";  $err = 21; break; }

      if (($img = $gimp->image_duplicate($canvas_img)) == false) {
	$errs = "Duplicate image\n";  $err = 22; break; }
      
      // Insert dell'immagine
      if (($lface = $gimp->layer_new($img,1000,1000,"RGBA-IMAGE","yourface",100,"NORMAL-MODE")) == false) {
	$errs = "New text1 layer\n";  $err = 22; break; }

      if ($gimp->image_add_layer($img, $lface, 12) == false) {
	$errs = "Add copy flatten\n";  $err = 23; break; }

      if ($gimp->server_transact_begin() == false) {
	$errs = "Transact begin\n";  $err = 25;	break; }

      if ($gimp->edit_copy($flatten) == false) {
	$errs = "Edit copy\n";  $err = 26; break; }

      if (($floatsel = $gimp->edit_paste($lface)) == false) {
	$errs = "Edit paste\n";  $err = 27; break; }
     
      if ($gimp->layer_set_offsets($floatsel, 0, 0) == false) {
	$errs = "layer set offset\n";  $err = 27; break; }

      if ($gimp->floating_sel_anchor($floatsel) == false) {
	$errs = "FSel anchor\n";  $err = 28; break; }
     
      if ($gimp->server_transact_finish() == false) {
	$errs = "Transact finish\n";  $err = 29; break; }

      if ($gimp->image_delete($in_img) == false) {
	$errs = "Delete image in\n";  $err = 24; break; }
      
      if ($gimp->layer_set_offsets($lface, 30, 50) == false) {
	$errs = "Set offsets lface\n";  $err = 24; break; }

      if (($ltxt1 = $gimp->layer_new($img,1700,1100,"RGBA-IMAGE","text1",100,"NORMAL-MODE")) == false) {
	$errs = "New text1 layer\n";  $err = 21; break; }
      
      if ($gimp->image_add_layer($img, $ltxt1, 0) == false) {
	$errs = "Add layer\n";  $err = 22; break; }

      if ($gimp->drawable_fill($ltxt1, 'TRANSPARENT') == false) {
	$errs = "Add layer\n";  $err = 22; break; }

      if ($gimp->set_font("Sans", 60, "PIXELS", true, 0) == false) {
	$errs = "set font\n";  $err = 18; break; }

      // dati iniziali per il testo da inserire
      $f_x =  830;
      $f_y =  372;
      $wmax = 665;
      $sz_end = 30;
      if (($flay = $gimp->text_ptsw_maxwidth($img, $ltxt1, $f_x, $f_y, $nome, 
					     $wmax, $sz_end)) == false) {
	$errs = "nome\n";  $err = 19; break; }
      if ($gimp->floating_sel_anchor($flay) == false) {
	$errs = "Merge down\n";  $err = 28; break; }
      
      $f_y += (81 - 14);
      if (($flay = $gimp->text_ptsw_maxwidth($img, $ltxt1, $f_x, $f_y, $cogn, 
					     $wmax, $sz_end)) == false) {
	$errs = "cogn\n";  $err = 19; break; }
      if ($gimp->floating_sel_anchor($flay) == false) {
	$errs = "Merge down\n";  $err = 28; break; }

      $f_y += (81 + 12);
      if (($flay = $gimp->text_ptsw_maxwidth($img, $ltxt1, $f_x, $f_y, $via, 
					     $wmax, $sz_end)) == false) {
	$errs = "nome\n";  $err = 19; break; }
      if ($gimp->floating_sel_anchor($flay) == false) {
	$errs = "Merge down\n";  $err = 28; break; }

      $f_y += (81 - 14);
      if (($flay = $gimp->text_ptsw_maxwidth($img, $ltxt1, $f_x, $f_y, $citt, 
					     $wmax, $sz_end)) == false) {
	$errs = "nome\n";  $err = 19; break; }
      if ($gimp->floating_sel_anchor($flay) == false) {
	$errs = "Merge down\n";  $err = 28; break; }

      $f_y += (81+11);
      if (($flay = $gimp->text_ptsw_maxwidth($img, $ltxt1, $f_x, $f_y, $numtes, 
					     $wmax, $sz_end)) == false) {
	$errs = "nome\n";  $err = 19; break; }
      if ($gimp->floating_sel_anchor($flay) == false) {
	$errs = "Merge down\n";  $err = 28; break; }

      // email
      if ($gimp->set_font("Sans", 40, "PIXELS", true, 0) == false) {
	$errs = "set font\n";  $err = 18; break; }
      $f_y += 81-3;
      if (($flay = $gimp->text_ptsw_maxwidth($img, $ltxt1, $f_x, $f_y, $email, 
					     $wmax, $sz_end)) == false) {
	$errs = "nome\n";  $err = 19; break; }
      if ($gimp->floating_sel_anchor($flay) == false) {
	$errs = "Merge down\n";  $err = 28; break; }


      // FPrint 1
      if ($gimp->set_font("Monospace", 40, "PIXELS", true, 0) == false) {
	$errs = "set font\n";  $err = 18; break; }
      $f_y +=81-5;
      if (strlen($finger2) > 0) {
	if (($flay = $gimp->text_ptsw_maxwidth($img, $ltxt1, $f_x, $f_y, $finger1, 
					       $wmax, $sz_end)) == false) {
	  $errs = "nome\n";  $err = 19; break; }
	if ($gimp->floating_sel_anchor($flay) == false) {
	  $errs = "Merge down\n";  $err = 28; break; }
      }
      // FPrint2
      $f_y += (81 - 31);
      if (strlen($finger2) > 0) {
	if (($flay = $gimp->text_ptsw_maxwidth($img, $ltxt1, $f_x, $f_y, $finger2, 
					       $wmax, $sz_end)) == false) {
	  $errs = "nome\n";  $err = 19; break; }
	if ($gimp->floating_sel_anchor($flay) == false) {
	  $errs = "Merge down\n";  $err = 28; break; }
      }
      if (strlen($finger1) == 0 && strlen($finger2) == 0) {
	// se fingerprint nulla, riassetta l'immagine
	if ($gimp->layer_translate($ltxt1, 0, 63) == false) {
	  $errs = "Merge down\n";  $err = 28; break; }

	if (($icone = $gimp->image_get_layer_by_name($img, "icone")) == false) {
	  $errs = "Merge down\n";  $err = 38; break; }
	
	if ($gimp->layer_translate($icone, 0, 63) == false) {
	  $errs = "Merge down\n";  $err = 48; break; }

	if (($ombra_icone = $gimp->image_get_layer_by_name($img, "ombra-icone")) == false) {
	  $errs = "Merge down\n";  $err = 38; break; }
	
	if ($gimp->layer_translate($ombra_icone, 0, 63) == false) {
	  $errs = "Merge down\n";  $err = 48; break; }
	// 730x860 850x990 120x130
	if ($gimp->rect_select_simple($img, 730, 860, 120, 130) == false) {
	  $errs = "Merge down\n";  $err = 48; break; }
	if ($gimp->edit_clear($icone) == false) {
	  $errs = "Merge down\n";  $err = 48; break; }
	
	if ($gimp->edit_clear($ombra_icone) == false) {
	  $errs = "Merge down\n";  $err = 48; break; }
      }
	

      if ($gimp->xcf_save($img, "/tmp/prostampa.xcf") == false) {
	$errs = "Save error\n";  $err = 21; break; }

      // flatten img
      if (($flatten = $gimp->image_flatten($img)) == false) {
	$errs = "Image flatten\n";  $err = 18; break; }
      // scale
      if ($gimp->image_scale($img, 17 * 40, 11 * 40) == false) {
	$errs = "Scale error\n";  $err = 4; break; }
      
      // save jpg
      if ($gimp->jpeg_save($img, "/tmp/prostampa.jpeg") == false) {
	$errs = "Save jpeg error\n";  $err = 21; break; }
      
      // delete img
      if ($gimp->image_delete($img) == false) {
	$errs = "Delete image in\n";  $err = 24; break; }
      // dump img
      header("Content-Type: image/jpeg");
      readfile("/tmp/prostampa.jpeg");
      // rm file
      unlink("/tmp/prostampa.jpeg");
      
      $gimp->close_connection($sock);
      $err = 0;
    } while (0);
  }
  if ($err != 0) {
    printf("ERRORE %d: [%s]<br>", $err, $errs);
    exit();
  }
}

/*
      $nome = "Marianna";
      $cogn = "Bishimashi";
      $via  = "Via Zirconio, 8";
      $citt = "Frittole (FI)";
      $numtes = "00021";
      //      $email = strtolow($nome).".".strtolow($cogn)."@milug.org";
      $email = "marianna.bishimashi@milug.org";
      $finger1 = "1122 3344 5566 7788 9900";
      $finger2 = "AABB CCDD EEFF 1122 3344";
*/

/*
 *
 *  MAIN
 *
 */

function main() 
{
  GLOBAL $ACT_FROM, $SUB;
  GLOBAL $userfile, $userfile_name, $userfile_size, $userfile_type;
  GLOBAL $nome, $cogn, $via, $citt, $numtes, $email, $finger1, $finger2;

  // select new state
  // echo "ACT_FROM $ACT_FROM<br>\n";
  if ($ACT_FROM == "STEP1") {
    // echo "DI QUI $nome $cogn<br>\n";
    if ($nome != "" && $cogn != "" && $via != "" && 
        $citt != "" && $numtes != "" && $email != "") {
      $ACTION = "STEP2";
    }
  }
  if ($ACT_FROM == "STEP2") {
    if ($SUB == "Submit") {
      if (is_uploaded_file($userfile)) 
	$ACTION = "ELABORATE";
      else
	$ACTION = "STEP2";
    }
    else if ($SUB == "Cancel") {
      $ACTION = "STEP1";
    }
  }

  // echo "ACTION $ACTION<br>\n";

  if($ACTION == "ELABORATE") {
    elaborate();
  }
  else if ($ACTION == "STEP2") {
?>
<html>
<body>
<div align=center>
<h2>Card Maker<h2>
</div>
<FORM ENCTYPE="multipart/form-data" ACTION="uplo.php" METHOD=POST>
<INPUT TYPE="hidden" name="ACT_FROM" value="STEP2">
<INPUT TYPE="hidden" name="MAX_FILE_SIZE" value="4096000">

<INPUT NAME="nome" TYPE="hidden" value="<?php echo "$nome"; ?>">
<INPUT NAME="cogn" TYPE="hidden" value="<?php echo "$cogn"; ?>">
<INPUT NAME="via" TYPE="hidden" value="<?php echo "$via"; ?>">
<INPUT NAME="citt" TYPE="hidden" value="<?php echo "$citt"; ?>">
<INPUT NAME="numtes" TYPE="hidden" value="<?php echo "$numtes"; ?>">
<INPUT NAME="email" TYPE="hidden" value="<?php echo "$email"; ?>">
<INPUT NAME="finger1" TYPE="hidden" value="<?php echo "$finger1"; ?>">
<INPUT NAME="finger2" TYPE="hidden" value="<?php echo "$finger2"; ?>">


      <table align="center" border="1" cellpadding=8>
      <tr><td>Name: </td><td align=center><? echo "$nome"; ?></td></tr>
<tr><td>Surname: </td><td align=center><? echo "$cogn"; ?></td></tr>
<tr><td>Address: </td><td align=center><? echo "$via"; ?></td></tr>
<tr><td>City: </td><td align=center><? echo "$citt"; ?></td></tr>
<tr><td>N. Card: </td><td align=center><? echo "$numtes"; ?></td></tr>
<tr><td>EMail: </td><td align=center><? echo "$email"; ?></td></tr>
<tr><td>FPrint: </td><td align=center><? echo "$finger1"; ?><br><? echo "$finger2"; ?></td></tr>
<tr><td>Image: </td><td align=center><INPUT NAME="userfile" TYPE="file"></td></tr>
<tr><td colspan=2 align=center><INPUT TYPE="SUBMIT" NAME="SUB" VALUE="Cancel"> <INPUT TYPE="SUBMIT" NAME="SUB" VALUE="Submit"></td></tr>
</table>
</FORM>
</body>
</html>
<?php
  }
  else { // STEP1
?>
<html>
<body>
<div align=center>
<h2>Card Maker<h2>
</div>
<FORM ENCTYPE="multipart/form-data" ACTION="uplo.php" METHOD=POST>
<INPUT TYPE="hidden" name="ACT_FROM" value="STEP1">
<INPUT TYPE="hidden" name="MAX_FILE_SIZE" value="4096000">
      <table align="center" border="1" cellpadding=8>
<tr><td>Name: </td><td align=center><INPUT NAME="nome" TYPE="text"  value="<?php echo "$nome"; ?>"></td></tr>
<tr><td>Surname: </td><td align=center><INPUT NAME="cogn" TYPE="text" value="<?php echo "$cogn"; ?>"></td></tr>
<tr><td>Address: </td><td align=center><INPUT NAME="via" TYPE="text" value="<?php echo "$via"; ?>"></td></tr>
<tr><td>City: </td><td align=center><INPUT NAME="citt" TYPE="text" value="<?php echo "$citt"; ?>"></td></tr>
<tr><td>N. Card: </td><td align=center><INPUT NAME="numtes" TYPE="text" value="<?php echo "$numtes"; ?>"></td></tr>
<tr><td>EMail: </td><td align=center><INPUT NAME="email" TYPE="text" value="<?php echo "$email"; ?>"></td></tr>
<tr><td>FPrint: </td><td align=center><INPUT NAME="finger1" TYPE="text" value="<?php echo "$finger1"; ?>"><br><INPUT NAME="finger2" TYPE="text" value="<?php echo "$finger2"; ?>"></td></tr>
<tr><td colspan=2 align=center><INPUT TYPE="SUBMIT" VALUE="Submit"></td></tr>
</table>
</FORM>
</body>
</html>
<?php
  }
}

main();
?>
